/*----- PROTECTED REGION ID(RfCav.h) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        RfCav.h
//
// description : Include file for the RfCav class
//
//
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef RfCav_H
#define RfCav_H

#include <tango/tango.h>

#include "dio.h"
#include "adc.h"
#include "dac.h"

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	RfCav.h

#ifdef TANGO_LOG
	// cppTango after c934adea (Merge branch 'remove-cout-definition' into 'main', 2022-05-23)
	// nothing to do
#else
	// cppTango 9.3-backports and older
	#define TANGO_LOG       cout
	#define TANGO_LOG_INFO  cout2
	#define TANGO_LOG_DEBUG cout3
#endif // TANGO_LOG

/**
 *  RfCav class description:
 *    
 */


namespace RfCav_ns
{
/*----- PROTECTED REGION ID(RfCav::Additional Class Declarations) ENABLED START -----*/
/* clang-format on */
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	RfCav::Additional Class Declarations

class RfCav : public TANGO_BASE_CLASS
{

/*----- PROTECTED REGION ID(RfCav::Data Members) ENABLED START -----*/
/* clang-format on */
	string initError;
	ADC *vltADC, *inpwrADC, *rflpwrADC, *positADC, *h2osecflowADC;
	DIO *inRangeDIO, *vacuumInterlockDIO, *pumpOnOffDIO, *h2oRemoteDIO,
	    *h2oOnDIO, *h2oResistor11OnDIO, *h2oResistor12OnDIO, 
	    *h2oPrimaryFlowDIO;
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	RfCav::Data Members

//	Device property data members
public:
	//	VltDevice:	
	std::string	vltDevice;
	//	VltCalibration:	
	std::vector<Tango::DevDouble>	vltCalibration;
	//	InpwrDevice:	
	std::string	inpwrDevice;
	//	InpwrCalibration:	
	std::vector<Tango::DevDouble>	inpwrCalibration;
	//	RflpwrDevice:	
	std::string	rflpwrDevice;
	//	RflpwrCalibration:	
	std::vector<Tango::DevDouble>	rflpwrCalibration;
	//	PositDevice:	
	std::string	positDevice;
	//	PositCalibration:	
	std::vector<Tango::DevDouble>	positCalibration;
	//	InRangeDevice:	
	std::string	inRangeDevice;
	//	vacuumInterlockDevice:	
	std::string	vacuumInterlockDevice;
	//	PumpOnOffDevice:	
	std::string	pumpOnOffDevice;
	//	SecFlowDevice:	
	std::string	secFlowDevice;
	//	SecFlowCalibration:	
	std::vector<Tango::DevDouble>	secFlowCalibration;
	//	H2oRemoteDevice:	
	std::string	h2oRemoteDevice;
	//	H2oOnDevice:	
	std::string	h2oOnDevice;
	//	H2oResistor11OnDevice:	
	std::string	h2oResistor11OnDevice;
	//	H2oResistor12OnDevice:	
	std::string	h2oResistor12OnDevice;
	//	H2oPrimaryFlowDevice:	
	std::string	h2oPrimaryFlowDevice;

	bool	mandatoryNotDefined;

//	Attribute data members
public:
	Tango::DevDouble	*attr_inPwr_read;
	Tango::DevDouble	*attr_posit_read;
	Tango::DevDouble	*attr_rflPwr_read;
	Tango::DevDouble	*attr_vlt_read;
	Tango::DevBoolean	*attr_inRange_read;
	Tango::DevBoolean	*attr_vacuumInterlock_read;
	Tango::DevDouble	*attr_h2oSecFlow_read;
	Tango::DevBoolean	*attr_h2oRemote_read;
	Tango::DevBoolean	*attr_h2oOn_read;
	Tango::DevBoolean	*attr_h2oResistor11On_read;
	Tango::DevBoolean	*attr_h2oResistor12On_read;
	Tango::DevBoolean	*attr_h2oPrimaryFlow_read;

//	Constructors and destructors
public:
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	RfCav(Tango::DeviceClass *cl,std::string &s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device Name
	 */
	RfCav(Tango::DeviceClass *cl,const char *s);
	/**
	 * Constructs a newly device object.
	 *
	 *	@param cl	Class.
	 *	@param s 	Device name
	 *	@param d	Device description.
	 */
	RfCav(Tango::DeviceClass *cl,const char *s,const char *d);
	/**
	 * The device object destructor.
	 */
	~RfCav();


//	Miscellaneous methods
public:
	/*
	 *	will be called at device destruction or at init command.
	 */
	void delete_device();
	/*
	 *	Initialize the device
	 */
	virtual void init_device();
	/*
	 *	Read the device properties from database
	 */
	void get_device_property();
	/*
	 *	Always executed method before execution command method.
	 */
	virtual void always_executed_hook();

	/*
	 *	Check if mandatory property has been set
	 */
	 void check_mandatory_property(Tango::DbDatum &class_prop, Tango::DbDatum &dev_prop);

//	Attribute methods
public:
	//--------------------------------------------------------
	/*
	 *	Method     : RfCav::read_attr_hardware()
	 *	Description: Hardware acquisition for attributes.
	 */
	//--------------------------------------------------------
	virtual void read_attr_hardware(std::vector<long> &attr_list);

/**
 *	Attribute inPwr related methods
 *	Description: input power kW
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_inPwr(Tango::Attribute &attr);
	virtual bool is_inPwr_allowed(Tango::AttReqType type);
/**
 *	Attribute posit related methods
 *	Description: tuning position
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_posit(Tango::Attribute &attr);
	virtual bool is_posit_allowed(Tango::AttReqType type);
/**
 *	Attribute rflPwr related methods
 *	Description: reflected power kW
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_rflPwr(Tango::Attribute &attr);
	virtual bool is_rflPwr_allowed(Tango::AttReqType type);
/**
 *	Attribute vlt related methods
 *	Description: gap voltage kV
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_vlt(Tango::Attribute &attr);
	virtual bool is_vlt_allowed(Tango::AttReqType type);
/**
 *	Attribute inRange related methods
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_inRange(Tango::Attribute &attr);
	virtual bool is_inRange_allowed(Tango::AttReqType type);
/**
 *	Attribute vacuumInterlock related methods
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_vacuumInterlock(Tango::Attribute &attr);
	virtual bool is_vacuumInterlock_allowed(Tango::AttReqType type);
/**
 *	Attribute h2oSecFlow related methods
 *
 *
 *	Data type:	Tango::DevDouble
 *	Attr type:	Scalar
 */
	virtual void read_h2oSecFlow(Tango::Attribute &attr);
	virtual bool is_h2oSecFlow_allowed(Tango::AttReqType type);
/**
 *	Attribute h2oRemote related methods
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_h2oRemote(Tango::Attribute &attr);
	virtual bool is_h2oRemote_allowed(Tango::AttReqType type);
/**
 *	Attribute h2oOn related methods
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_h2oOn(Tango::Attribute &attr);
	virtual bool is_h2oOn_allowed(Tango::AttReqType type);
/**
 *	Attribute h2oResistor11On related methods
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_h2oResistor11On(Tango::Attribute &attr);
	virtual bool is_h2oResistor11On_allowed(Tango::AttReqType type);
/**
 *	Attribute h2oResistor12On related methods
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_h2oResistor12On(Tango::Attribute &attr);
	virtual bool is_h2oResistor12On_allowed(Tango::AttReqType type);
/**
 *	Attribute h2oPrimaryFlow related methods
 *
 *
 *	Data type:	Tango::DevBoolean
 *	Attr type:	Scalar
 */
	virtual void read_h2oPrimaryFlow(Tango::Attribute &attr);
	virtual bool is_h2oPrimaryFlow_allowed(Tango::AttReqType type);


	//--------------------------------------------------------
	/**
	 *	Method     : RfCav::add_dynamic_attributes()
	 *	Description: Add dynamic attributes if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_attributes();




//	Command related methods
public:
	/**
	 *	Command PumpOn related method
	 *
	 *
	 */
	virtual void pump_on();
	virtual bool is_PumpOn_allowed(const CORBA::Any &any);
	/**
	 *	Command PumpOff related method
	 *
	 *
	 */
	virtual void pump_off();
	virtual bool is_PumpOff_allowed(const CORBA::Any &any);


	//--------------------------------------------------------
	/**
	 *	Method     : RfCav::add_dynamic_commands()
	 *	Description: Add dynamic commands if any.
	 */
	//--------------------------------------------------------
	void add_dynamic_commands();

/*----- PROTECTED REGION ID(RfCav::Additional Method prototypes) ENABLED START -----*/
/* clang-format on */
	void check_init();
	void check_state();

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	RfCav::Additional Method prototypes
};

/*----- PROTECTED REGION ID(RfCav::Additional Classes Definitions) ENABLED START -----*/
/* clang-format on */
//	Additional Classes Definitions
/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	RfCav::Additional Classes Definitions

}	//	End of namespace

#endif   //	RfCav_H
