/*----- PROTECTED REGION ID(RfCavClass.h) ENABLED START -----*/
/* clang-format on */
//=============================================================================
//
// file :        RfCavClass.h
//
// description : Include for the RfCav root class.
//               This class is the singleton class for
//                the RfCav device class.
//               It contains all properties and methods which the
//               RfCav requires only once e.g. the commands.
//
//
//
// This file is part of Tango device class.
//
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
//
//
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================


#ifndef RfCavClass_H
#define RfCavClass_H

#include <tango.h>
#include "RfCav.h"

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	RfCavClass.h


namespace RfCav_ns
{
/*----- PROTECTED REGION ID(RfCavClass::classes for dynamic creation) ENABLED START -----*/
/* clang-format on */

/* clang-format off */
/*----- PROTECTED REGION END -----*/	//	RfCavClass::classes for dynamic creation

//=========================================
//	Define classes for attributes
//=========================================
//	Attribute inPwr class definition
class inPwrAttrib: public Tango::Attr
{
public:
	inPwrAttrib():Attr("inPwr",
			Tango::DEV_DOUBLE, Tango::READ) {}
	~inPwrAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<RfCav *>(dev))->read_inPwr(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<RfCav *>(dev))->is_inPwr_allowed(ty);}
};

//	Attribute posit class definition
class positAttrib: public Tango::Attr
{
public:
	positAttrib():Attr("posit",
			Tango::DEV_DOUBLE, Tango::READ) {}
	~positAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<RfCav *>(dev))->read_posit(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<RfCav *>(dev))->is_posit_allowed(ty);}
};

//	Attribute rflPwr class definition
class rflPwrAttrib: public Tango::Attr
{
public:
	rflPwrAttrib():Attr("rflPwr",
			Tango::DEV_DOUBLE, Tango::READ) {}
	~rflPwrAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<RfCav *>(dev))->read_rflPwr(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<RfCav *>(dev))->is_rflPwr_allowed(ty);}
};

//	Attribute vlt class definition
class vltAttrib: public Tango::Attr
{
public:
	vltAttrib():Attr("vlt",
			Tango::DEV_DOUBLE, Tango::READ) {}
	~vltAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<RfCav *>(dev))->read_vlt(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<RfCav *>(dev))->is_vlt_allowed(ty);}
};

//	Attribute inRange class definition
class inRangeAttrib: public Tango::Attr
{
public:
	inRangeAttrib():Attr("inRange",
			Tango::DEV_BOOLEAN, Tango::READ) {}
	~inRangeAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<RfCav *>(dev))->read_inRange(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<RfCav *>(dev))->is_inRange_allowed(ty);}
};

//	Attribute vacuumInterlock class definition
class vacuumInterlockAttrib: public Tango::Attr
{
public:
	vacuumInterlockAttrib():Attr("vacuumInterlock",
			Tango::DEV_BOOLEAN, Tango::READ) {}
	~vacuumInterlockAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<RfCav *>(dev))->read_vacuumInterlock(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<RfCav *>(dev))->is_vacuumInterlock_allowed(ty);}
};

//	Attribute h2oSecFlow class definition
class h2oSecFlowAttrib: public Tango::Attr
{
public:
	h2oSecFlowAttrib():Attr("h2oSecFlow",
			Tango::DEV_DOUBLE, Tango::READ) {}
	~h2oSecFlowAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<RfCav *>(dev))->read_h2oSecFlow(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<RfCav *>(dev))->is_h2oSecFlow_allowed(ty);}
};

//	Attribute h2oRemote class definition
class h2oRemoteAttrib: public Tango::Attr
{
public:
	h2oRemoteAttrib():Attr("h2oRemote",
			Tango::DEV_BOOLEAN, Tango::READ) {}
	~h2oRemoteAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<RfCav *>(dev))->read_h2oRemote(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<RfCav *>(dev))->is_h2oRemote_allowed(ty);}
};

//	Attribute h2oOn class definition
class h2oOnAttrib: public Tango::Attr
{
public:
	h2oOnAttrib():Attr("h2oOn",
			Tango::DEV_BOOLEAN, Tango::READ) {}
	~h2oOnAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<RfCav *>(dev))->read_h2oOn(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<RfCav *>(dev))->is_h2oOn_allowed(ty);}
};

//	Attribute h2oResistor11On class definition
class h2oResistor11OnAttrib: public Tango::Attr
{
public:
	h2oResistor11OnAttrib():Attr("h2oResistor11On",
			Tango::DEV_BOOLEAN, Tango::READ) {}
	~h2oResistor11OnAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<RfCav *>(dev))->read_h2oResistor11On(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<RfCav *>(dev))->is_h2oResistor11On_allowed(ty);}
};

//	Attribute h2oResistor12On class definition
class h2oResistor12OnAttrib: public Tango::Attr
{
public:
	h2oResistor12OnAttrib():Attr("h2oResistor12On",
			Tango::DEV_BOOLEAN, Tango::READ) {}
	~h2oResistor12OnAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<RfCav *>(dev))->read_h2oResistor12On(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<RfCav *>(dev))->is_h2oResistor12On_allowed(ty);}
};

//	Attribute h2oPrimaryFlow class definition
class h2oPrimaryFlowAttrib: public Tango::Attr
{
public:
	h2oPrimaryFlowAttrib():Attr("h2oPrimaryFlow",
			Tango::DEV_BOOLEAN, Tango::READ) {}
	~h2oPrimaryFlowAttrib() {}
	virtual void read(Tango::DeviceImpl *dev,Tango::Attribute &att)
		{(static_cast<RfCav *>(dev))->read_h2oPrimaryFlow(att);}
	virtual bool is_allowed(Tango::DeviceImpl *dev,Tango::AttReqType ty)
		{return (static_cast<RfCav *>(dev))->is_h2oPrimaryFlow_allowed(ty);}
};


//=========================================
//	Define classes for commands
//=========================================
//	Command PumpOn class definition
class PumpOnClass : public Tango::Command
{
public:
	PumpOnClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	PumpOnClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~PumpOnClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<RfCav *>(dev))->is_PumpOn_allowed(any);}
};

//	Command PumpOff class definition
class PumpOffClass : public Tango::Command
{
public:
	PumpOffClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out,
				   const char        *in_desc,
				   const char        *out_desc,
				   Tango::DispLevel  level)
	:Command(cmd_name,in,out,in_desc,out_desc, level)	{}

	PumpOffClass(const char   *cmd_name,
	               Tango::CmdArgType in,
				   Tango::CmdArgType out)
	:Command(cmd_name,in,out)	{}
	~PumpOffClass() {}

	virtual CORBA::Any *execute (Tango::DeviceImpl *dev, const CORBA::Any &any);
	virtual bool is_allowed (Tango::DeviceImpl *dev, const CORBA::Any &any)
	{return (static_cast<RfCav *>(dev))->is_PumpOff_allowed(any);}
};


/**
 *	The RfCavClass singleton definition
 */

#ifdef _TG_WINDOWS_
class __declspec(dllexport)  RfCavClass : public Tango::DeviceClass
#else
class RfCavClass : public Tango::DeviceClass
#endif
{
	/*----- PROTECTED REGION ID(RfCavClass::Additional DServer data members) ENABLED START -----*/
	/* clang-format on */
	//	Add your own code
	/* clang-format off */
	/*----- PROTECTED REGION END -----*/	//	RfCavClass::Additional DServer data members

	public:
		//	write class properties data members
		Tango::DbData	cl_prop;
		Tango::DbData	cl_def_prop;
		Tango::DbData	dev_def_prop;
		//	Method prototypes
		static RfCavClass *init(const char *);
		static RfCavClass *instance();
		~RfCavClass();
		Tango::DbDatum	get_class_property(std::string &);
		Tango::DbDatum	get_default_device_property(std::string &);
		Tango::DbDatum	get_default_class_property(std::string &);

	protected:
		RfCavClass(std::string &);
		static RfCavClass *_instance;
		void command_factory();
		void attribute_factory(std::vector<Tango::Attr *> &);
		void pipe_factory();
		void write_class_property();
		void set_default_property();
		void get_class_property();
		std::string get_cvstag();
		std::string get_cvsroot();

	private:
		void device_factory(TANGO_UNUSED(const Tango::DevVarStringArray *));
		void create_static_attribute_list(std::vector<Tango::Attr *> &);
		void erase_dynamic_attributes(const Tango::DevVarStringArray *,std::vector<Tango::Attr *> &);
		std::vector<std::string>	defaultAttList;
		Tango::Attr *get_attr_object_by_name(std::vector<Tango::Attr *> &att_list, std::string attname);
};

}	//	End of namespace

#endif   //	RfCav_H
